# Compute B_{m,\chi} for some character chi with conductor f to within eps

def BernEval(m, chi, eps):
    """
    
    """
    #prec = 16*m;
    prec = 500
    C = ComplexField(prec)
    R = RealField(prec)
    eps = R(eps)
    i = C.0
    if not chi.is_primitive():
        raise ValueError, "chi (=%s) must be primitive"%chi
    f = chi.conductor()
    mfact = factorial(m)
    K = (-1)^(m-1) * 2 * mfact * C(f/(2*i))^C(m)
    P = R(pi)
    PM = P^m
    GS = chi.gauss_sum_numerical(prec)
    delta = abs((PM*GS)/K)*eps    # accuracy that we have to compute L(chi,m) to.
    N = int( (delta^(-1/(m-1))).ceil() )
    phi = chi.base_ring().complex_embedding(prec)
    L = sum([phi(chi(n))/(n^m) for n in range(1,N)])
    return K/(PM*GS)*L

### Test It Out
def test_kevin():
    eps = 0.001
    B = BernEval(5,5,eps)
    B1 = (-148+86*i)/5
    err = abs(CC(B) - B1)
    print err<eps

    B = BernEval(7,5,eps)
    B1 = (-2366*i + 3892)/5
    err = abs(CC(B) - B1)
    print err<eps



    #G = DirichletGroup(f, C)
    #chi = G.0
    #GS = C(0.0)
    #zetaf = C(exp(2*P*C(i)/f))
    #for n in range(1, f):
    #  GS = GS + C(chi(n))*zetaf^C(n)
    #print GS0, GS
  
